function varargout=configure(varargin)
% FUNCTION fc_oogmsh.configure()
%   Configures the toolbox/package by setting gmsh path, meshes default 
%   directory and .geo files default directory.
%   Theses informations will be stored in ... file.
%
% <COPYRIGHT>
  [conffile,isFileExists]=fc_graphics4mesh.getLocalConfFile();
  fullname=mfilename('fullpath');
  I=strfind(fullname,filesep);
  Path=fullname(1:(I(end-1)-1));
  if isFileExists
    run(conffile);
  else
    data_dir=[Path,filesep,'data'];
    fc_tools_dir=''; % empty if pkg or toolbox in path
  end
  p = inputParser;
  p.addParamValue('data_dir',data_dir,@ischar);
  p.addParamValue('fc_tools_dir',fc_tools_dir,@ischar);
  %p.addParamValue('force',false,@islogical); 
  p.parse(varargin{:});
  R=p.Results;
  
  if ~isdir(R.data_dir), error('Not a directory :\n''data_dir''=%s\n', R.data_dir); end
  
%    if ~isempty(R.fc_tools_dir) 
%      if ~exist(R.fc_tools_dir,'dir') 
%        error('Directory %s doesn''t exist!', R.fc_tools_dir)
%      end
%      if check_toolbox('tools')
%        warning('The <fc-tools> toolbox/package is already in path!')
%      else
%        addpath(R.fc_tools_dir)
%        if ~check_toolbox('tools')
%          error('Unable to load the <fc-tools> toolbox/package in directory:\n   %s\n',R.fc_tools_dir)
%        end
%        rmpath(R.fc_tools_dir)
%      end
%    else
%      if check_toolbox('tools')
%        R.fc_tools_dir=fc_tools.path();
%      else % try to guess
%        apath=fullfile(fullname(1:(I(end-2)-1)),'fc-tools');
%        if exist(apath,'dir')
%          addpath(apath)
%          if ~check_toolbox('tools')
%            error('Unable to load the <fc-tools> toolbox/package in directory:\n   %s\n',apath)
%          end
%          rmpath(apath)
%          R.fc_tools_dir=apath;
%        else
%          error('Unable to load the <fc-tools> toolbox/package in directory:\n   %s\n',apath)
%        end
%      end
%    end
  R.fc_tools_dir=get_pathtoolbox('tools',R.fc_tools_dir);
  
  fprintf('Write in %s ...\n',conffile);
  fid=fopen(conffile,'w');
  if (fid==0), error('Unable to open file :\n %s\n',conffile);end
  fprintf(fid,'%% Automaticaly generated with fc_graphics4mesh.configure()\n');
  fprintf(fid,'data_dir=''%s'';\n',R.data_dir);
  fprintf(fid,'fc_tools_dir=''%s'';\n',R.fc_tools_dir);
  fclose(fid);
  fprintf('  -> done\n');
  if nargout==1,varargout{1}=conffile;end
end

function out_dir=get_pathtoolbox(shortname,var_dir)
  if ~isempty(var_dir) 
    if ~exist(var_dir,'dir') 
      error('Directory %s doesn''t exist!', var_dir)
    end
    if check_toolbox(shortname)
      warning('The <fc-%s> toolbox/package is already in path!',shortname)
    else
      addpath(var_dir)
      if ~check_toolbox(shortname)
        error('Unable to load the <fc-%s> toolbox/package in directory:\n   %s\n',shortname,var_dir)
      end
      rmpath(var_dir)
      out_dir=var_dir;
    end
  else
    if check_toolbox(shortname)
      out_dir=eval('fc_%s.path()',shortname);
    else % try to guess
      fullname=mfilename('fullpath');
      I=strfind(fullname,filesep);
      apath=fullfile(fullname(1:(I(end-2)-1)),['fc-',shortname]);
      if exist(apath,'dir')
        addpath(apath)
        if ~check_toolbox(shortname)
          error('Unable to load the <fc-%s> toolbox/package in directory:\n   %s\n',shortname,apath)
        end
        rmpath(apath)
        out_dir=apath;
      else
        error('Unable to load the <fc-%s> toolbox/package in directory:\n   %s\n',shortname,apath)
      end
    end
  end
end

function res=check_toolbox(shortname)
  try 
    eval(['fc_',shortname,'.init()'])
  catch
    res=false;return;
  end
  res=true;
end